unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, AppBar, msofficepanel, ExtCtrls, StdCtrls, Buttons,
  Menus, op_NoTask, op_TrayIcon, op_common;

const
  REG_SETTINGS   = 'Software\Office Panel';

type
  TfrmMain = class(TAppBar)
    opTitle: TopTitle;
    pmSysMenu: TPopupMenu;
    Mininize1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    CustomizePanel1: TMenuItem;
    opCustom: TopCustom;
    opTrayIcon: TopTrayIcon;
    opNoTask: TopNoTask;
    opMain: TopPanel;
    opStandard: TopTab;
    opGradient: TopTab;
    opColor: TopTab;
    opBitmap: TopTab;
    btnHomePage: TopButton;
    btnExit: TopButton;
    opSeparator1: TopSeparator;
    btnCustomize: TopButton;
    opSeparator2: TopSeparator;
    pmTrayMenu: TPopupMenu;
    miShow: TMenuItem;
    N3: TMenuItem;
    Exit2: TMenuItem;
    N4: TMenuItem;
    Customize1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnHomePageClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure opTitleSysMenuDblClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure CustomizePanel1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Mininize1Click(Sender: TObject);
    procedure miShowClick(Sender: TObject);
  private
    { Private declarations }
    procedure DoActivate(Sender: TObject);
    procedure DoDeactivate(Sender: TObject);
    procedure CheckAutoRun;

    procedure WMSize(var Msg: TWMSize); message WM_SIZE;
  protected
    procedure OnExitSizeMove (var Msg : TMessage); message WM_EXITSIZEMOVE;
  public
    { Public declarations }
    procedure UpdateBar; override;
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}

uses ShellAPI, Registry;
 
procedure TfrmMain.FormCreate(Sender: TObject);
begin
  ClientHeight := 49;
  // AutoRun checking
  CheckAutoRun;
  // Default setiings
  MinWidth        := 460;
  MinHeight       := 49;
  VertDockSize    := 34;
  HorzDockSize    := 34;
  MinVertDockSize := 34;
  MinHorzDockSize := 34;
  HorzSizeInc     := 5;
  VertSizeInc     := 5;
  FloatLeft   := Left;
  FloatTop    := Top;
  FloatRight  := Left + Width;
  FloatBottom := Top + Height;
  // Load settings from the registry
  LoadSettings;
  // Update the appbar
  UpdateBar;
  opMain.LoadSettings;
  // Hook Active Event on Application
  Application.OnActivate := DoActivate;
  Application.OnDeActivate := DoDeActivate;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  // Save settings to the registry
  opMain.SaveSettings;
  SaveSettings;
end;

procedure TfrmMain.OnExitSizeMove (var Msg : TMessage);
begin
  // Hide Icon on TaskBar
  inherited ;
  If (opNoTask <> nil) and (Edge = abeFloat) Then
    opNoTask.HideForm := true;
end;

procedure TfrmMain.CheckAutoRun; // check Auto Run
var
  Reg: TRegistry;
begin
{  If not ReadBool(rsAutoRun, rsAutoRun, true) Then Exit;
  Reg := TRegistry.Create;
  try
    with Reg do
    begin
      RootKey := HKEY_LOCAL_MACHINE;
      OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Run', False);
      If ReadString(ExtractFileName(ParamStr(0))) = '' Then
        If MessageDlg('You want to run program when Windows start?', mtConfirmation,
          [mbYes, mbNo], 0) = mrYes Then
          WriteString(ExtractFileName(ParamStr(0)), ParamStr(0));
    end;
  finally
    Reg.Free;
  end;}
end;

procedure TfrmMain.btnHomePageClick(Sender: TObject);
begin
  ShellExecute(0, 'open', 'http://www.evgesoft.com/dev/', nil, nil, SW_SHOWNORMAL);
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.opTitleSysMenuDblClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.UpdateBar;
begin
  // Override UpDateBar;
  inherited UpDateBar;
  If (opNoTask <> nil) and (Edge = abeFloat) Then
    opNoTask.HideForm := true;
end;

procedure TfrmMain.CustomizePanel1Click(Sender: TObject);
begin
  // Customize Panel
  opCustom.Execute;
  UpdateBar;
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
  // Hide Task
  If opNoTask <> nil Then
    opNoTask.HideForm := true;
end;

procedure TfrmMain.DoActivate(Sender: TObject);
begin
  If opTitle <> nil Then
    opTitle.Invalidate;
  UpdateBar;
end;

procedure TfrmMain.DoDeactivate(Sender: TObject);
begin
  If opTitle <> nil Then
    opTitle.Invalidate;
end;

procedure TfrmMain.WMSize(var Msg: TWMSize);
begin
  // Resize
  inherited ;
  opMain.WMSize(Msg);
end;

procedure TfrmMain.Mininize1Click(Sender: TObject);
begin
  // Minimize
  miShow.Enabled := true;
  Hide;
end;

procedure TfrmMain.miShowClick(Sender: TObject);
begin
  // Show Panel
  miShow.Enabled := false;
  Show;
end;

end.
